import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * Ici est la classe de la porte qui enpèche le passage vers la fin du niveau si on a pas pris la clé permettant de l'ouvrir
 * 
 * @author Kylian Bezard et Alexandre Mascaro
 * @version 1.0
 */
public class Door_locked extends Actor
{
    /**
     * Act - do whatever the Door_locked wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private boolean Over;
    /**
     * cete fonction définit la taille de l'objet
     */
    public Door_locked(){
        GreenfootImage img = this.getImage();
        img.scale((int)(img.getWidth()/2),(int)(img.getHeight()/2));
    }
    /**
     * cette fonction est utilisée pour regarder si il y a la clé en item dans le monde pour définir l'aura voulu.
     */
    public void act() 
    {
        Over();
        if(Over == true && getWorld().getObjects(Door_aura.class).size() == 0){
            KEY();
        }
        if(Over == false && getWorld().getObjects(Door_aura.class).size() == 1){
            getWorld().getObjects(Door_aura.class).get(0).Remove();
        }
        if(Over == true && getWorld().getObjects(Key.class).size() == 1 && Greenfoot.isKeyDown("e")){
            getWorld().addObject(new Door_open(),getX(),getY());
            getWorld().removeObject(this);
        }
    }
    private void Over(){
        List<Body> InRange = getObjectsInRange(50, Body.class);
        if(Greenfoot.getMouseInfo() != null &&
            Greenfoot.getMouseInfo().getX() >= (this.getX()-this.getImage().getWidth()/2) && Greenfoot.getMouseInfo().getX() <= (this.getX()+this.getImage().getWidth()/2) 
            && Greenfoot.getMouseInfo().getY() >= (this.getY()-this.getImage().getHeight()/2) && Greenfoot.getMouseInfo().getY() <= (this.getY()+this.getImage().getHeight()/2)
            && InRange.size() != 0){
            Over = true;
        }else{
            Over = false;
        }
    }
    private void KEY(){
        if(getWorld().getObjects(Key.class).size() == 0){
            getWorld().addObject(new Door_aura("images/porte_aura_false.png"),this.getX(),this.getY());
        }
        if(getWorld().getObjects(Key.class).size() == 1){
            getWorld().addObject(new Door_aura("images/porte_aura.png"),this.getX(),this.getY());
        }
    }
}
