import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * classe du coffre contenant la clé du niveau 
 * 
 * @author Kylian Bezard et Alexandre Mascaro
 * @version 1.0
 */
public class Chest extends Actor{
    private boolean Over;
    public Chest(){
        GreenfootImage img = this.getImage();
        img.scale((int)(img.getWidth()/2),(int)(img.getHeight()/2));
    }
    /**
     * cette fonction est utilisée faire apparaitre la clé en item dans le monde et apparaitre l'aura du coffre
     */
    public void act() 
    {
        Over();
        if(Over == true && getWorld().getObjects(Chest_aura.class).size() == 0){
            getWorld().addObject(new Chest_aura(),this.getX(),this.getY());
        }
        if(Over == false && getWorld().getObjects(Chest_aura.class).size() == 1){
            getWorld().getObjects(Chest_aura.class).get(0).Remove();
        }
        if(Over == true && Greenfoot.isKeyDown("e") && getWorld().getObjects(Key.class).size() == 0){
            getWorld().addObject(new Key(),1430,70);
        }
    }
    private void Over(){
        List<Body> InRange = getObjectsInRange(30, Body.class);
        if(Greenfoot.getMouseInfo() != null &&
            Greenfoot.getMouseInfo().getX() >= (this.getX()-this.getImage().getWidth()/2) && Greenfoot.getMouseInfo().getX() <= (this.getX()+this.getImage().getWidth()/2) 
            && Greenfoot.getMouseInfo().getY() >= (this.getY()-this.getImage().getHeight()/2) && Greenfoot.getMouseInfo().getY() <= (this.getY()+this.getImage().getHeight()/2)
            && InRange.size() != 0){
            Over = true;
        }else{
            Over = false;
        }
    }
}
