import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * cette classe est l'aura du coffre
 * 
 * @author Kylian Bezard et Alexandre Mascaro
 * @version 1.0
 */
public class Chest_aura extends Actor{
    float i=0;
    int Width;
    int Height;
    /**
     * définit le caractéristiques de l'objet
     */
    public Chest_aura(){
        GreenfootImage img = new GreenfootImage(getImage());
        img.scale(img.getWidth()/2 + 10,img.getHeight()/2 + 10);
        img.setTransparency(150);
        Width = (int)(getImage().getWidth()/1.5);
        Height = (int)(getImage().getHeight()/1.5);
        this.setImage(img);
    }
    /**
     * cette fonction crée l'animation de grosissement et rétrécissement de l'aura
     */
    public void act(){
        i = i+0.05f;
        getImage().scale((int)(Width*(1+(float)2*Math.toRadians((float)Math.sin((float)i)))), Height);
    }
    /**
     * cet fonction est appelée pour supprimer cet objet dans le monde
     */
    public void Remove(){
        getWorld().removeObject(this);
    }
}