import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import java.util.ArrayList;

/**
 * cette classe est celle qui génère le monde
 * 
 * @param isGround1 est une variable qui sert dans la class Body pour regarder si le personnage est sur le sol ou contre un mur.
 * 
 * @author Kylian Bezard et Alexandre Mascaro
 * @version 1.0
 */

public class cell extends Actor{
    int addY;
    int y1;
    int addX;
    int x1;
    
    int SpawnX;
    public boolean isGround1;
    /**
     * cette fonction définit les caractéristiques de l'objet
     * @param Y définit la hauteur du mure
     * @param X défini de quelle longueur il doit faire une plateforme a une hauteur @see Random
     * @param Random définit la hauteur a laquelle la plateforme doit être construite si @see X n'est pas égal à 0
     * @param isGround définit si oui ou non c'est un sol. S'il ne l'est pas il est donc automatiquement un mur
     */
    public cell(int Y, int X, int Random, boolean isGround){
        addY = Y;
        y1 = Math.abs(Y);
        addX = X;
        x1 = X;
        SpawnX = Random;
        if(isGround == true){
            isGround1 = true;
        }else{
            isGround1 = false;
        }
    }
    /**
     * fonction appelée chaques images et sert a créer le monde le monde lors du chargement
     */
    public void act(){
        if(getWorld().getObjects(chargement_screen.class).get(0).KKK < 80){
            if(y1 != 0){
                test1();
            }
            if(y1 == 0){
                test2();
            }
        }
    }
    private void test1(){
        if(y1 != 1){
            y1 = 1;
            getWorld().addObject(new cell(addY-(Math.abs(addY)/addY),addX,SpawnX,isGround1), getX(), (getY()+((Math.abs(addY)/addY)*20)));
        }
        if(Math.abs(addY) == SpawnX && x1 != 0){
            x1 = 0;
            getWorld().addObject(new cell(0,addX-(int)(addX/Math.abs(addX)),SpawnX,true), getX()+(int)((addX/Math.abs(addX))*20), getY());
        }
    }
    private void test2(){
        if(x1 != 0){
            x1 = 0;
            getWorld().addObject(new cell(0,addX-(int)(addX/Math.abs(addX)),SpawnX,true), getX()+(int)((addX/Math.abs(addX))*20), getY());
        }
    }
    private int RandomHighX(){
        return Greenfoot.getRandomNumber(3)+2;
    }
}